(****************************************)
(* Light Menus Components (Demo)        *)
(* Version 1.0                          *)
(*                                      *)
(****************************************)
(* (c) 1996-98 Evgeny A. Kryukov        *)
(* All right reserved.                  *)
(*                                      *)
(****************************************)
(* Internet: aepp@vsgtu.eastsib.ru      *)
(* WWW:                                 *)
(*   http://www.ita.eastsib.ru          *)
(****************************************)
unit demo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, LightMenus, Menus, Buttons;

type
  TfrmDemo = class(TForm)
    Image1: TImage;
    lmlAbout: TlmLabel;
    lmlHome: TlmLabel;
    lmlMail: TlmLabel;
    lmPanel1: TlmPanel;
    lmPanel2: TlmPanel;
    lmPanel3: TlmPanel;
    lmPanel4: TlmPanel;
    lmPanel5: TlmPanel;
    lmPanel6: TlmPanel;
    lmPanel7: TlmPanel;
    lmPanel8: TlmPanel;
    lmMain: TlmMenu;
    Rect1: TMenuItem;
    r11: TMenuItem;
    r21: TMenuItem;
    r31: TMenuItem;
    r41: TMenuItem;
    r51: TMenuItem;
    rwer1: TMenuItem;
    ttet1: TMenuItem;
    Bevel1: TBevel;
    c21: TMenuItem;
    c31: TMenuItem;
    c41: TMenuItem;
    c51: TMenuItem;
    c61: TMenuItem;
    c71: TMenuItem;
    Colums1: TMenuItem;
    col11: TMenuItem;
    col12: TMenuItem;
    col13: TMenuItem;
    col14: TMenuItem;
    col21: TMenuItem;
    col22: TMenuItem;
    col31: TMenuItem;
    col32: TMenuItem;
    col33: TMenuItem;
    col34: TMenuItem;
    col35: TMenuItem;
    col36: TMenuItem;
    lmPanel9: TlmPanel;
    btnFolder: TBitBtn;
    lmPopup: TlmPopupMenu;
    Rectangle1: TMenuItem;
    Color1: TMenuItem;
    Columns1: TMenuItem;
    r12: TMenuItem;
    r22: TMenuItem;
    r32: TMenuItem;
    r42: TMenuItem;
    r52: TMenuItem;
    c11: TMenuItem;
    c22: TMenuItem;
    c32: TMenuItem;
    c42: TMenuItem;
    c52: TMenuItem;
    c62: TMenuItem;
    c72: TMenuItem;
    col15: TMenuItem;
    col23: TMenuItem;
    col37: TMenuItem;
    col41: TMenuItem;
    col24: TMenuItem;
    col25: TMenuItem;
    col26: TMenuItem;
    col27: TMenuItem;
    col38: TMenuItem;
    col39: TMenuItem;
    col310: TMenuItem;
    col311: TMenuItem;
    Shape1: TShape;
    Shape2: TShape;
    lmFolderMenu: TlmFolderMenu;
    lmLabel1: TlmLabel;
    Bevel2: TBevel;
    cbSmallIcon: TCheckBox;
    cbShowFiles: TCheckBox;
    cbNoSubFolders: TCheckBox;
    lmlRegistration: TlmLabel;
    procedure lmlAboutMouseEnter(Sender: TObject);
    procedure lmlAboutMouseLeave(Sender: TObject);
    procedure lmlHomeMouseEnter(Sender: TObject);
    procedure lmlHomeMouseLeave(Sender: TObject);
    procedure lmlMailMouseEnter(Sender: TObject);
    procedure lmlMailMouseLeave(Sender: TObject);
    procedure lmlHomeClick(Sender: TObject);
    procedure lmlMailClick(Sender: TObject);
    procedure lmlAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lmMainMeasureItem(MenuItem: TMenuItem; var Width,
      Height: Integer; Canvas: TCanvas);
    procedure lmMainDrawItem(MenuItem: TMenuItem; Canvas: TCanvas;
      ItemState: Integer; ItemRect: TRect);
    procedure r51Click(Sender: TObject);
    procedure c71Click(Sender: TObject);
    procedure btnFolderClick(Sender: TObject);
    procedure cbSmallIconClick(Sender: TObject);
    procedure cbShowFilesClick(Sender: TObject);
    procedure cbNoSubFoldersClick(Sender: TObject);
    procedure lmlRegistrationMouseEnter(Sender: TObject);
    procedure lmlRegistrationMouseLeave(Sender: TObject);
    procedure lmlRegistrationClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

implementation

{$R *.DFM}

uses ShellAPI, About;

const
  IBrush: array [1..5] of TBrushStyle = (bsSolid, bsBDiagonal,
    bsFDiagonal, bsCross, bsDiagCross);
  IColor: array [1..7] of TColor = (clGreen, clRed, clBlue,
    clYellow, clWhite, clBlack, clFuchsia);

procedure TfrmDemo.lmlAboutMouseEnter(Sender: TObject);
begin
  lmlAbout.Font.Color := clHighlight;
  lmlAbout.Font.Style := lmlAbout.Font.Style + [fsUnderline];
end;

procedure TfrmDemo.lmlAboutMouseLeave(Sender: TObject);
begin
  lmlAbout.Font.Color := clWindowText;
  lmlAbout.Font.Style := lmlAbout.Font.Style - [fsUnderline];
end;

procedure TfrmDemo.lmlHomeMouseEnter(Sender: TObject);
begin
  lmlHome.Font.Color := clHighlight;
  lmlHome.Font.Style := lmlHome.Font.Style + [fsUnderline];
end;

procedure TfrmDemo.lmlHomeMouseLeave(Sender: TObject);
begin
  lmlHome.Font.Color := clWindowText;
  lmlHome.Font.Style := lmlHome.Font.Style - [fsUnderline];
end;

procedure TfrmDemo.lmlMailMouseEnter(Sender: TObject);
begin
  lmlMail.Font.Color := clHighlight;
  lmlMail.Font.Style := lmlMail.Font.Style + [fsUnderline];
end;

procedure TfrmDemo.lmlMailMouseLeave(Sender: TObject);
begin
  lmlMail.Font.Color := clWindowText;
  lmlMail.Font.Style := lmlMail.Font.Style - [fsUnderline];
end;

procedure TfrmDemo.lmlRegistrationMouseEnter(Sender: TObject);
begin
  lmlRegistration.Font.Color := clHighlight;
  lmlRegistration.Font.Style := lmlRegistration.Font.Style + [fsUnderline];
end;

procedure TfrmDemo.lmlRegistrationMouseLeave(Sender: TObject);
begin
  lmlRegistration.Font.Color := clWindowText;
  lmlRegistration.Font.Style := lmlRegistration.Font.Style - [fsUnderline];
end;

procedure TfrmDemo.lmlHomeClick(Sender: TObject);
begin
// home Page
  ShellExecute(0, 'open', 'http://www.ita.eastsib.ru', nil, nil, SW_SHOWNORMAL);
end;


procedure TfrmDemo.lmlRegistrationClick(Sender: TObject);
begin
// Registration home Page
  ShellExecute(0, 'open', 'http://www.ita.eastsib.ru/registration.html', nil, nil, SW_SHOWNORMAL);
end;

procedure TfrmDemo.lmlMailClick(Sender: TObject);
begin
// Mail
  ShellExecute(0, 'open', 'mailto:aepp@vsgtu.eastsib.ru', nil, nil, SW_SHOWNORMAL);
end;

procedure TfrmDemo.lmlAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmDemo.FormCreate(Sender: TObject);
begin
  {$IFNDEF VER90}
    {$IFNDEF VER93}
    lmlAbout.Cursor := crHandPoint;
    lmlHome.Cursor := crHandPoint;
    lmlMail.Cursor := crHandPoint;
    {$ENDIF VER93}
  {$ENDIF VER90}
  lmFolderMenu.Folder := ExtractFilePath(ParamStr(0))+'Folder\';
end;

procedure TfrmDemo.lmMainMeasureItem(MenuItem: TMenuItem; var Width,
  Height: Integer; Canvas: TCanvas);
begin
  case MenuItem.Tag of
    1: begin
         Width := 100;
         Height := 40;
       end;
    2: begin
         Width := 80;
         Height := 26;
       end;
    3: begin
         Width := 40;
         Height := 40;
       end;
    4: begin
         Width := 90;
         Height := 22;
       end;
  end;
end;

procedure TfrmDemo.lmMainDrawItem(MenuItem: TMenuItem; Canvas: TCanvas;
  ItemState: Integer; ItemRect: TRect);
begin
  InflateRect(ItemRect, -2, -2);
  case MenuItem.Tag of
    1: with Canvas do
       begin
         If ItemState and msSelected <> 0 Then
         begin
           Brush.Color := clHighlight;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end
         else
         begin
           Brush.Color := clBtnFace;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         Brush.Color := clBtnHighlight;
         Brush.Style := IBrush[MenuItem.GroupIndex];
         Pen.Style := psSolid;
         Pen.Color := clBtnShadow;
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
       end;
    2: with Canvas do
       begin
         If ItemState and msSelected <> 0 Then
         begin
           Brush.Color := clHighlight;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end
         else
         begin
           Brush.Color := clBtnFace;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         Brush.Color := IColor[MenuItem.GroupIndex];
         Pen.Style := psSolid;
         Pen.Color := clBtnShadow;
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           RoundRect(Left, Top, Right, Bottom, 7, 7);
       end;
    3: with Canvas do
       begin
         If ItemState and msSelected <> 0 Then
         begin
           Brush.Color := clHighlight;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end
         else
         begin
           Brush.Color := clBtnFace;
           Pen.Style := psSolid;
           Pen.Color := clBtnShadow;
         end;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         Brush.Color := IColor[MenuItem.GroupIndex];
         Pen.Style := psSolid;
         Pen.Color := clBtnShadow;
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           RoundRect(Left, Top, Right, Bottom, 8, 8);
       end;
    4: with Canvas do
       begin
         Pen.Style := psClear;
         If ItemState and msSelected <> 0 Then
           Brush.Color := clHighlight
         else
           Brush.Color := clBtnFace;
         with ItemRect do
           Rectangle(Left, Top, Right, Bottom);
         InflateRect(ItemRect, -3, -3);
         with ItemRect do
           TextOut(Left+4, (Top+Bottom) div 2 -
             TextHeight(MenuItem.Caption) div 2, MenuItem.Caption);
       end;
  end;
end;

procedure TfrmDemo.r51Click(Sender: TObject);
begin
  Shape1.Brush.Style := IBrush[(Sender as TMenuItem).GroupIndex];
  Shape2.Brush.Style := IBrush[(Sender as TMenuItem).GroupIndex];
end;

procedure TfrmDemo.c71Click(Sender: TObject);
begin
  Shape1.Brush.Color := IColor[(Sender as TMenuItem).GroupIndex];
  Shape2.Brush.Color := IColor[(Sender as TMenuItem).GroupIndex];
end;

procedure TfrmDemo.btnFolderClick(Sender: TObject);
var
  P: TPoint;
begin
  P := btnFolder.ClientToScreen(Point(0, btnFolder.Height));
  lmFolderMenu.Popup(P.X, P.Y);
end;

procedure TfrmDemo.cbSmallIconClick(Sender: TObject);
begin
  lmFolderMenu.SmallIcon := cbSmallIcon.Checked;
end;

procedure TfrmDemo.cbShowFilesClick(Sender: TObject);
begin
  lmFolderMenu.ShowFiles := cbShowFiles.Checked;
end;

procedure TfrmDemo.cbNoSubFoldersClick(Sender: TObject);
begin
  lmFolderMenu.NoSubFolder := cbNoSubFolders.Checked;
end;

end.
